#include "nmea0183.h"
#pragma hdrstop

/*
** Author: Samuel R. Blackburn
** Internet: sam_blackburn@pobox.com
**
** You can use it any way you like as long as you don't try to sell it.
**
** Copyright, 1996, Samuel R. Blackburn
**
** $Workfile: p.cpp $
** $Revision: 4 $
** $Modtime: 10/10/98 2:42p $
*/

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

P::P()
{
   Mnemonic = "P";
   Empty();
}

P::~P()
{
   Mnemonic.Empty();
   Empty();
}

void P::Empty( void )
{
   Sentence.Empty();
   Source.Empty();
}

BOOL P::Parse( const SENTENCE& sentence )
{
   /*
   ** This is where parsing of proprietary sentences will go...
   */

   Sentence = sentence;

   CString temp_string = sentence.Field( 0 );

   Source      = temp_string.Mid( 1, 3 );
   CompanyName = Manufacturers[ Source ];

   TRACE1( "Source is   \"%s\"\n", (const char *) Source );
   TRACE1( "CompanyName \"%s\"\n", (const char *) CompanyName );

   return( TRUE );
}

BOOL P::Write( SENTENCE& sentence )
{
   /*
   ** Let the parent do its thing
   */
   
   RESPONSE::Write( sentence );

   sentence += Sentence;

   sentence.Finish();

   return( TRUE );
}

const P& P::operator = ( const P& source )
{
   Sentence = source.Sentence;

   return( *this );
}
